-- edge
--
-- edge modelliert eine Flankenerkennung

library ieee;
use ieee.std_logic_1164.all;

entity edge is
	port(
		clk : in std_logic; -- Takt
		clr_n : in std_logic := '1'; -- asynchroner Ruecksetzeingang
		data : in std_logic; -- Eingangssignal
		detected : out std_logic -- Taktflanke wurde erkannt
	);
end entity edge;


architecture behaviour of edge is
begin
	process (clk, clr_n)
		variable last : std_logic ; -- vorheriger Zustand
	begin
		if clr_n = '0' then 
				detected <= '0';
				last := '0';
		elsif clk = '1' and clk'event then
			edge_detect: if (last = '0' or last = 'L') and (data='1' or data='H') then
				detected <= '1'; 
			else 
				detected <= '0';
			end if edge_detect;
			last := data;
		end if;
	end process;
end architecture behaviour;
