-- Tastatur-Simulation fr testbench.vhdl

LIBRARY IEEE;
USE IEEE.std_logic_1164.all;

entity keybrd is
	port(
		tdata : out std_logic := '1'; -- serielle Tastaturdaten
		tclk : out std_logic := '1' -- Tastaturtakt
	);
end entity keybrd;


architecture behave of keybrd is
	constant pause : delay_length := 1 ms;
	constant t : delay_length := 25 us;
	constant startbit : std_logic := '0';
	constant stopbit : std_logic := '1';
	constant length : natural := 8;
	constant max_nr : natural := 17;
	type tastaturcode is array (length-1 downto 0) of std_logic;
	type tastaturcode_mit_parity is record
		code : tastaturcode;
		parity : std_logic; -- odd parity !
	end record tastaturcode_mit_parity;  
	type tastaturcodes is array(1 to max_nr) of tastaturcode_mit_parity;
	constant eingabe : tastaturcodes := 
	(
		(code => X"44", parity => '1'),
		(code => X"24", parity => '1'),
		(code => X"F0", parity => '1'),
--		(code => X"44", parity => '1'), 
		(code => X"44", parity => '0'), -- parity wrong
		(code => X"1C", parity => '0'),
		(code => X"4B", parity => '1'),
		(code => X"4B", parity => '1'),
		(code => X"44", parity => '1'),
--		(code => X"29", parity => '0'),
		(code => X"29", parity => '1'), -- parity wrong
		(code => X"44", parity => '1'),
		(code => X"1D", parity => '1'),
		(code => X"F0", parity => '1'),
		(code => X"44", parity => '1'),
		(code => X"24", parity => '1'),
		(code => X"2B", parity => '1'),
		(code => X"2C", parity => '0'),
		(code => X"49", parity => '0')
	);
begin 
	process
	begin
		for nr in 1 to max_nr loop
			wait for pause;
			tdata <= startbit;
			wait for t;
			tclk <= '0';
			wait for t;
			wait for t;
			tclk <= '1';
			wait for t;
			for i in length-1 downto 0 loop
				tdata <= eingabe(nr).code(i);
				wait for t;
				tclk <= '0';
				wait for t;
				wait for t;
				tclk <= '1';
				wait for t;
			end loop;
			tdata <= eingabe(nr).parity;
			wait for t;
			tclk <= '0';
			wait for t;
			wait for t;
			tclk <= '1';
			wait for t;
			tdata <= stopbit;
			wait for t;
			tclk <= '0';
			wait for t;
			wait for t;
			tclk <= '1';
			wait for t;
			wait for t;
		end loop;
		wait;
	end process;
end architecture behave;
